/**********
 * Copyright (c) 2003-2004 Greg Parker.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY GREG PARKER ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **********/

#ifndef BN_ARMSTUBS_H
#define BN_ARMSTUBS_H

#include <stdint.h>
#include <PceNativeCall.h>

// "Globals" for ARM code. There is one permanent instance of this. 
// It is passed through bn_args.p68K and is pointed to by most BN objects 
// (BIGNUM, BN_CTX, et al.)
// THIS MUST MATCH the layout of struct pace_globals!
typedef struct {
    void *emulState; 
    Call68KFuncType *call68K;
    uint32_t rand_bytes;    // address of RAND_bytes()
    uint32_t assert_failed; // address of assert_failed()
    uint32_t arena_malloc;  // address of arena_malloc()
    uint32_t arena_free;    // address of arena_free()
    char *bn_bits;       // static data for BN_num_bits_word
} bn_globals;

#endif
